<template>
    <div class="filter_content">
        <el-button :plain="true" @click="switchOpen" :class="stateCLass" size='mini' :icon="stateIcon">{{stateMsg}}</el-button>
        <div v-if="opened">
            <filter-group class="filter-box">
                <span v-for="(filter, key) in params" :key="key">
                    <el-select v-if="filter.type === 'select'" class="select"
                            v-model="value[key]"
                            filterable
                            :multiple="filter.options['multiple']"
                            :clearable="true"
                            reserve-keyword
                            :placeholder="filter.placeholder"
                            :style="filter.style"
                            >
                        <el-option v-for="item in filter.items" :key="item.value"
                            :label="item.label"
                            :value="item.value">
                        </el-option>
                    </el-select>
                    <el-date-picker v-else-if="filter.type === 'datepicker'"
                        v-model="value[key]"
                        type="date"
                        :picker-options="pickerOptions[key]"
                        value-format="yyyy-MM-dd"
                        :placeholder="filter.placeholder">
                    </el-date-picker>
                    <el-checkbox-group v-else-if="filter.type === 'checkboxGroup'" v-model="value[key]">
                        <el-checkbox v-for="opt in filter.options" :key="opt.value" :label="opt.value">{{opt.label}}</el-checkbox>
                    </el-checkbox-group>
                    <el-input v-else :placeholder="filter.placeholder" v-model="value[key]"></el-input>
                 </span>
            </filter-group>
            <div class="filter-box__btns">
                <el-button @click="resetFilter" :disabled="disabled" plain>
                    Reset filters
                </el-button>
                <el-button @click="initFilter" type="primary" :disabled="disabled">
                    Apply filters
                </el-button>
                <slot name="btns-after"></slot>
            </div>
        </div>
    </div>
</template>

<script>
import filterGroup from '@/components/FilterGroup';

export default {
    props: {
        /** config for the complex filter UIs */
        params: {
            type: Object,
            required: true,
        },
        /** filter values */
        value: {
            type: Object,
            required: true,
        },
        /** disable action buttons */
        disabled: {
            type: Boolean,
            required: false,
            default: false,
        },
        /** date picker options */
        pickerOptions: {
            type: Object,
            required: false,
            default: () => {},
        },
    },
    components: {
        filterGroup,
    },
    data() {
        return {
            btnOpened: null,
        };
    },
    computed: {
        initOpened: vm => vm.viewport().width > 768,
        opened: (vm) => {
            if (vm.btnOpened === null) {
                return vm.initOpened;
            }
            return vm.btnOpened;
        },
        stateMsg: vm => (vm.opened ? 'hide filters' : 'show filters'),
        stateCLass: vm => (vm.opened ? 'opened' : 'closed'),
        stateIcon: vm => (vm.opened ? 'el-icon-arrow-up' : 'el-icon-arrow-down'),
    },
    methods: {
        /**
         * Dispatch apply filter event
         */
        initFilter() {
            this.$emit('apply', this.value);
        },
        /**
         * Dispatch reset filter event
         */
        resetFilter() {
            this.$emit('reset');
        },
        /**
         * Switch open/close collapse filter section
         */
        switchOpen() {
            this.btnOpened = !this.opened;
        },
    },
};
</script>

<style lang="stylus" scoped>
.filter_content
    margin: 1rem 0

.filter-box
    flex-wrap: wrap
    width: 100%

    &__btns
        display: flex
        margin-top: 1rem
        margin-bottom: 2rem


span > .el-input, .select
    width: 17rem
    margin-right: .5rem
    margin-bottom: .4rem

.opened
    border-color: $base_blue
    color: $base_blue

.closed
    border-color: $base_gray !important
    color: $dark_gray !important

    &:hover
        border-color: $base_blue !important
        color: $base_blue !important

.filter-box__btns
    display: flex
    flex-wrap: wrap

</style>
